
#' api
#'
#' api
#' @param ... authentication parameters
#' @keywords api
#' @export
#' @examples
#' \dontrun{
#' api()
#' }
api <- function(...){
  api_object(...)
}

api_object <- function(...){
  name_api <- "eea.nilu"
  register_api <- "https://eea-api.nilu.no/"
  client_api <- rapiclient::get_api(url = "https://eea-api.nilu.no/swagger/v1/swagger.json",type="swagger")
  operations <- rapiclient::get_operations(client_api,...)


  object <- local({

    register <- function(openURL=TRUE){
      if(openURL){
        utils::browseURL(register_api)
      } else return(register_api)
    }

    help <- function(name=NULL){
      if (!is.null(name)) {
        utils::str(operations[name])
      } else names(operations)
    }

    e1a <- function(...) {
      res <- operations$e1a(...)
      res <- httr::content(res)
      return(res)
    }
    e2a <- function(...) {
      res <- operations$e2a(...)
      res <- httr::content(res)
      return(res)
    }
    metadata <- function(...) {
      res <- operations$metadata(...)
      res <- httr::content(res)
      return(res)
    }


    summary <- function(){
      print(paste0(name_api," client api"))
    }

    environment()
    })
    lockEnvironment(object, TRUE)
    structure(object, class=c("api", class(object)))
}
